]> git.karo-electronics.de Git - karo-tx-uboot.git/blob - MAKEALL
MAKEALL: make sure to invoke GNU Make
[karo-tx-uboot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier:      GPL-2.0+
7
8 usage()
9 {
10         # if exiting with 0, write to stdout, else write to stderr
11         local ret=${1:-0}
12         [ "${ret}" -eq 1 ] && exec 1>&2
13         cat <<-EOF
14         Usage: MAKEALL [options] [--] [boards-to-build]
15
16         Options:
17           -a ARCH,   --arch ARCH       Build all boards with arch ARCH
18           -c CPU,    --cpu CPU         Build all boards with cpu CPU
19           -v VENDOR, --vendor VENDOR   Build all boards with vendor VENDOR
20           -s SOC,    --soc SOC         Build all boards with soc SOC
21           -b BOARD,  --board BOARD     Build all boards with board name BOARD
22           -l,        --list            List all targets to be built
23           -m,        --maintainers     List all targets and maintainer email
24           -M,        --mails           List all targets and all affilated emails
25           -C,        --check           Enable build checking
26           -n,        --continue        Continue (skip boards already built)
27           -r,        --rebuild-errors  Rebuild any boards that errored
28           -h,        --help            This help output
29
30         Selections by these options are logically ANDed; if the same option
31         is used repeatedly, such selections are ORed.  So "-v FOO -v BAR"
32         will select all configurations where the vendor is either FOO or
33         BAR.  Any additional arguments specified on the command line are
34         always build additionally.  See the boards.cfg file for more info.
35
36         If no boards are specified, then the default is "powerpc".
37
38         Environment variables:
39           BUILD_NCPUS      number of parallel make jobs (default: auto)
40           CROSS_COMPILE    cross-compiler toolchain prefix (default: "")
41           CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42                            architecture "ARCH".  Substitute "ARCH" for any
43                            supported architecture (default: "")
44           MAKEALL_LOGDIR   output all logs to here (default: ./LOG/)
45           BUILD_DIR        output build directory (default: ./)
46           BUILD_NBUILDS    number of parallel targets (default: 1)
47
48         Examples:
49           - build all Power Architecture boards:
50               MAKEALL -a powerpc
51               MAKEALL --arch powerpc
52               MAKEALL powerpc
53           - build all PowerPC boards manufactured by vendor "esd":
54               MAKEALL -a powerpc -v esd
55           - build all PowerPC boards manufactured either by "keymile" or "siemens":
56               MAKEALL -a powerpc -v keymile -v siemens
57           - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58               MAKEALL -c mpc83xx -v freescale 4xx
59         EOF
60         exit ${ret}
61 }
62
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
65
66 # Option processing based on util-linux-2.13/getopt-parse.bash
67
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
71 # getopt.
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73      -n 'MAKEALL' -- "$@"`
74
75 [ $? != 0 ] && usage 1
76
77 # Note the quotes around `$TEMP': they are essential!
78 eval set -- "$TEMP"
79
80 SELECTED=''
81 ONLY_LIST=''
82 PRINT_MAINTS=''
83 MAINTAINERS_ONLY=''
84 CONTINUE=''
85 REBUILD_ERRORS=''
86
87 while true ; do
88         case "$1" in
89         -a|--arch)
90                 # echo "Option ARCH: argument \`$2'"
91                 if [ "$opt_a" ] ; then
92                         opt_a="${opt_a%)} || \$2 == \"$2\")"
93                 else
94                         opt_a="(\$2 == \"$2\")"
95                 fi
96                 SELECTED='y'
97                 shift 2 ;;
98         -c|--cpu)
99                 # echo "Option CPU: argument \`$2'"
100                 if [ "$opt_c" ] ; then
101                         opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
102                 else
103                         opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
104                 fi
105                 SELECTED='y'
106                 shift 2 ;;
107         -s|--soc)
108                 # echo "Option SoC: argument \`$2'"
109                 if [ "$opt_s" ] ; then
110                         opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
111                 else
112                         opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
113                 fi
114                 SELECTED='y'
115                 shift 2 ;;
116         -v|--vendor)
117                 # echo "Option VENDOR: argument \`$2'"
118                 if [ "$opt_v" ] ; then
119                         opt_v="${opt_v%)} || \$5 == \"$2\")"
120                 else
121                         opt_v="(\$5 == \"$2\")"
122                 fi
123                 SELECTED='y'
124                 shift 2 ;;
125         -b|--board)
126                 # echo "Option BOARD: argument \`$2'"
127                 if [ "$opt_b" ] ; then
128                         opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129                 else
130                         # We need to check the 7th field too
131                         # for boards whose 6th field is "-"
132                         opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133                 fi
134                 SELECTED='y'
135                 shift 2 ;;
136         -C|--check)
137                 CHECK='C=1'
138                 shift ;;
139         -n|--continue)
140                 CONTINUE='y'
141                 shift ;;
142         -r|--rebuild-errors)
143                 REBUILD_ERRORS='y'
144                 shift ;;
145         -l|--list)
146                 ONLY_LIST='y'
147                 shift ;;
148         -m|--maintainers)
149                 ONLY_LIST='y'
150                 PRINT_MAINTS='y'
151                 MAINTAINERS_ONLY='y'
152                 shift ;;
153         -M|--mails)
154                 ONLY_LIST='y'
155                 PRINT_MAINTS='y'
156                 shift ;;
157         -h|--help)
158                 usage ;;
159         --)
160                 shift ; break ;;
161         *)
162                 echo "Internal error!" >&2 ; exit 1 ;;
163         esac
164 done
165
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167         echo "GNU Make not found" >&2
168         exit 1
169 }
170
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
173
174 FILTER="\$1 !~ /^#/"
175 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
176 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
177 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
178 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
179 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
180
181 if [ "$SELECTED" ] ; then
182         SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
183
184         # Make sure some boards from boards.cfg are actually found
185         if [ -z "$SELECTED" ] ; then
186                 echo "Error: No boards selected, invalid arguments"
187                 exit 1
188         fi
189 fi
190
191 #########################################################################
192
193 # Print statistics when we exit
194 trap exit 1 2 3 15
195 trap print_stats 0
196
197 # Determine number of CPU cores if no default was set
198 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
199
200 if [ "$BUILD_NCPUS" -gt 1 ]
201 then
202         JOBS="-j $((BUILD_NCPUS + 1))"
203 else
204         JOBS=""
205 fi
206
207 if [ "${MAKEALL_LOGDIR}" ] ; then
208         LOG_DIR=${MAKEALL_LOGDIR}
209 else
210         LOG_DIR="LOG"
211 fi
212
213 : ${BUILD_NBUILDS:=1}
214 BUILD_MANY=0
215
216 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
217         BUILD_MANY=1
218         : ${BUILD_DIR:=./build}
219         mkdir -p "${BUILD_DIR}/ERR"
220         find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
221 fi
222
223 : ${BUILD_DIR:=.}
224
225 OUTPUT_PREFIX="${BUILD_DIR}"
226
227 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
228 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
229         find "${LOG_DIR}/" -type f -exec rm -f {} +
230 fi
231
232 LIST=""
233
234 # Keep track of the number of builds and errors
235 ERR_CNT=0
236 ERR_LIST=""
237 WRN_CNT=0
238 WRN_LIST=""
239 TOTAL_CNT=0
240 SKIP_CNT=0
241 CURRENT_CNT=0
242 OLDEST_IDX=1
243 RC=0
244
245 # Helper funcs for parsing boards.cfg
246 targets_by_field()
247 {
248         field=$1
249         regexp=$2
250
251         awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
252                                                                 boards.cfg
253 }
254
255 targets_by_arch() { targets_by_field 2 "$@" ; }
256 targets_by_cpu()  { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
257 targets_by_soc()  { targets_by_field 4 "$@" ; }
258
259 #########################################################################
260 ## MPC5xx Systems
261 #########################################################################
262
263 LIST_5xx="$(targets_by_cpu mpc5xx)"
264
265 #########################################################################
266 ## MPC5xxx Systems
267 #########################################################################
268
269 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
270
271 #########################################################################
272 ## MPC512x Systems
273 #########################################################################
274
275 LIST_512x="$(targets_by_cpu mpc512x)"
276
277 #########################################################################
278 ## MPC8xx Systems
279 #########################################################################
280
281 LIST_8xx="$(targets_by_cpu mpc8xx)"
282
283 #########################################################################
284 ## PPC4xx Systems
285 #########################################################################
286
287 LIST_4xx="$(targets_by_cpu ppc4xx)"
288
289 #########################################################################
290 ## MPC824x Systems
291 #########################################################################
292
293 LIST_824x="$(targets_by_cpu mpc824x)"
294
295 #########################################################################
296 ## MPC8260 Systems (includes 8250, 8255 etc.)
297 #########################################################################
298
299 LIST_8260="$(targets_by_cpu mpc8260)"
300
301 #########################################################################
302 ## MPC83xx Systems (includes 8349, etc.)
303 #########################################################################
304
305 LIST_83xx="$(targets_by_cpu mpc83xx)"
306
307 #########################################################################
308 ## MPC85xx Systems (includes 8540, 8560 etc.)
309 #########################################################################
310
311 LIST_85xx="$(targets_by_cpu mpc85xx)"
312
313 #########################################################################
314 ## MPC86xx Systems
315 #########################################################################
316
317 LIST_86xx="$(targets_by_cpu mpc86xx)"
318
319 #########################################################################
320 ## 74xx/7xx Systems
321 #########################################################################
322
323 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
324
325 #########################################################################
326 ## PowerPC groups
327 #########################################################################
328
329 LIST_TSEC="             \
330         ${LIST_83xx}    \
331         ${LIST_85xx}    \
332         ${LIST_86xx}    \
333 "
334
335 LIST_powerpc="          \
336         ${LIST_5xx}     \
337         ${LIST_512x}    \
338         ${LIST_5xxx}    \
339         ${LIST_8xx}     \
340         ${LIST_824x}    \
341         ${LIST_8260}    \
342         ${LIST_83xx}    \
343         ${LIST_85xx}    \
344         ${LIST_86xx}    \
345         ${LIST_4xx}     \
346         ${LIST_74xx_7xx}\
347 "
348
349 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
350 # still using "ppc" instead of "powerpc"
351 LIST_ppc="              \
352         ${LIST_powerpc} \
353 "
354
355 #########################################################################
356 ## StrongARM Systems
357 #########################################################################
358
359 LIST_SA="$(targets_by_cpu sa1100)"
360
361 #########################################################################
362 ## ARM7 Systems
363 #########################################################################
364
365 LIST_ARM7="$(targets_by_cpu arm720t)"
366
367 #########################################################################
368 ## ARM9 Systems
369 #########################################################################
370
371 LIST_ARM9="$(targets_by_cpu arm920t)    \
372         $(targets_by_cpu arm926ejs)     \
373         $(targets_by_cpu arm946es)      \
374 "
375
376 #########################################################################
377 ## ARM11 Systems
378 #########################################################################
379 LIST_ARM11="$(targets_by_cpu arm1136)   \
380         $(targets_by_cpu arm1176)       \
381 "
382
383 #########################################################################
384 ## ARMV7 Systems
385 #########################################################################
386
387 LIST_ARMV7="$(targets_by_cpu armv7)"
388
389 #########################################################################
390 ## ARMV8 Systems
391 #########################################################################
392
393 LIST_ARMV8="$(targets_by_cpu armv8)"
394
395 #########################################################################
396 ## AT91 Systems
397 #########################################################################
398
399 LIST_at91="$(targets_by_soc at91)"
400
401 #########################################################################
402 ## Xscale Systems
403 #########################################################################
404
405 LIST_pxa="$(targets_by_cpu pxa)"
406
407 #########################################################################
408 ## SPEAr Systems
409 #########################################################################
410
411 LIST_spear="$(targets_by_soc spear)"
412
413 #########################################################################
414 ## ARM groups
415 #########################################################################
416
417 LIST_arm="$(targets_by_arch arm |               \
418         for ARMV8_TARGET in $LIST_ARMV8;        \
419                 do sed "/$ARMV8_TARGET/d";      \
420         done)                                   \
421 "
422
423 #########################################################################
424 ## MIPS Systems         (default = big endian)
425 #########################################################################
426
427 LIST_mips="$(targets_by_arch mips)"
428
429 #########################################################################
430 ## OpenRISC Systems
431 #########################################################################
432
433 LIST_openrisc="$(targets_by_arch openrisc)"
434
435 #########################################################################
436 ## x86 Systems
437 #########################################################################
438
439 LIST_x86="$(targets_by_arch x86)"
440
441 #########################################################################
442 ## Nios-II Systems
443 #########################################################################
444
445 LIST_nios2="$(targets_by_arch nios2)"
446
447 #########################################################################
448 ## MicroBlaze Systems
449 #########################################################################
450
451 LIST_microblaze="$(targets_by_arch microblaze)"
452
453 #########################################################################
454 ## ColdFire Systems
455 #########################################################################
456
457 LIST_m68k="$(targets_by_arch m68k)"
458 LIST_coldfire=${LIST_m68k}
459
460 #########################################################################
461 ## AVR32 Systems
462 #########################################################################
463
464 LIST_avr32="$(targets_by_arch avr32)"
465
466 #########################################################################
467 ## Blackfin Systems
468 #########################################################################
469
470 LIST_blackfin="$(targets_by_arch blackfin)"
471
472 #########################################################################
473 ## SH Systems
474 #########################################################################
475
476 LIST_sh2="$(targets_by_cpu sh2)"
477 LIST_sh3="$(targets_by_cpu sh3)"
478 LIST_sh4="$(targets_by_cpu sh4)"
479
480 LIST_sh="$(targets_by_arch sh)"
481
482 #########################################################################
483 ## SPARC Systems
484 #########################################################################
485
486 LIST_sparc="$(targets_by_arch sparc)"
487
488 #########################################################################
489 ## NDS32 Systems
490 #########################################################################
491
492 LIST_nds32="$(targets_by_arch nds32)"
493
494 #########################################################################
495 ## ARC Systems
496 #########################################################################
497
498 LIST_arc="$(targets_by_arch arc)"
499
500 #-----------------------------------------------------------------------
501
502 get_target_location() {
503         local target=$1
504         local BOARD_NAME=""
505         local CONFIG_NAME=""
506         local board=""
507         local vendor=""
508
509         # Automatic mode
510         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
511         if [ -z "${line}" ] ; then echo "" ; return ; fi
512
513         set ${line}
514
515         CONFIG_NAME="${7%_config}"
516
517         [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}"
518
519         if [ $# -gt 5 ]; then
520                 if [ "$6" = "-" ] ; then
521                         board=${BOARD_NAME}
522                 else
523                         board="$6"
524                 fi
525         fi
526
527         [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
528         [ $# -gt 6 ] && [ "$8" != "-" ] && {
529                 tmp="${8%:*}"
530                 if [ "$tmp" ] ; then
531                         CONFIG_NAME="$tmp"
532                 fi
533         }
534
535         # Assign board directory to BOARDIR variable
536         if [ "${vendor}" == "-" ] ; then
537             BOARDDIR=${board}
538         else
539             BOARDDIR=${vendor}/${board}
540         fi
541
542         echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
543 }
544
545 get_target_maintainers() {
546         local name=`echo $1 | cut -d : -f 3`
547
548         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
549         if [ -z "${line}" ]; then
550                 echo ""
551                 return ;
552         fi
553
554         local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
555         [ "$mails" == "-" ] && mails=""
556         echo "$mails"
557 }
558
559 get_target_arch() {
560         local target=$1
561
562         # Automatic mode
563         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
564
565         if [ -z "${line}" ] ; then echo "" ; return ; fi
566
567         set ${line}
568         echo "$2"
569 }
570
571 list_target() {
572         if [ "$PRINT_MAINTS" != 'y' ] ; then
573                 echo "$1"
574                 return
575         fi
576
577         echo -n "$1:"
578
579         local loc=`get_target_location $1`
580
581         if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
582
583         local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
584
585         if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
586
587                 local dir=`echo ${loc} | cut -d ":" -f 2`
588                 local cfg=`echo ${loc} | cut -d ":" -f 1`
589                 local git_result=`git log --format=%aE board/${dir} \
590                                 include/configs/${cfg}.h | grep "@"`
591                 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
592                                                 head -n 3`
593                 local git_result_top=`echo ${git_result} | tr " " "\n" | \
594                         sort | uniq -c | sort -nr | head -n 3 | \
595                         sed "s/^ \+[0-9]\+ \+//"`
596
597                 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
598                         sort -u | tr "\n" " " | sed "s/ $//" ;
599         else
600                 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
601                                                 sed "s/ $//" ;
602         fi
603
604         echo ""
605 }
606
607 # Each finished build will have a file called ${donep}${n},
608 # where n is the index of the build. Each build
609 # we've already noted as finished will have ${skipp}${n}.
610 # The code managing the build process will use this information
611 # to ensure that only BUILD_NBUILDS builds are in flight at once
612 donep="${LOG_DIR}/._done_"
613 skipp="${LOG_DIR}/._skip_"
614
615 build_target_killed() {
616         echo "Aborted $target build."
617         # Remove the logs for this board since it was aborted
618         rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
619         exit
620 }
621
622 build_target() {
623         target=$1
624         build_idx=$2
625
626         if [ "$ONLY_LIST" == 'y' ] ; then
627                 list_target ${target}
628                 return
629         fi
630
631         if [ $BUILD_MANY == 1 ] ; then
632                 output_dir="${OUTPUT_PREFIX}/${target}"
633                 mkdir -p "${output_dir}"
634                 trap build_target_killed TERM
635         else
636                 output_dir="${OUTPUT_PREFIX}"
637         fi
638
639         target_arch=$(get_target_arch ${target})
640         eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
641         if [ "${cross_toolchain}" ] ; then
642             MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
643         elif [ "${CROSS_COMPILE}" ] ; then
644             MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
645         else
646             MAKE=$GNU_MAKE
647         fi
648
649         if [  "${output_dir}" != "." ] ; then
650                 MAKE="${MAKE} O=${output_dir}"
651         fi
652
653         ${MAKE} distclean >/dev/null
654         ${MAKE} -s ${target}_config
655
656         ${MAKE} ${JOBS} ${CHECK} all \
657                 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
658
659         # Check for 'make' errors
660         if [ ${PIPESTATUS[0]} -ne 0 ] ; then
661                 RC=1
662         fi
663
664         if [ $BUILD_MANY == 1 ] ; then
665                 trap - TERM
666
667                 ${MAKE} -s clean
668
669                 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
670                         cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
671                 else
672                         rm ${LOG_DIR}/${target}.ERR
673                 fi
674         else
675                 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
676                         if grep -iw error ${LOG_DIR}/${target}.ERR ; then
677                                 : $(( ERR_CNT += 1 ))
678                                 ERR_LIST="${ERR_LIST} $target"
679                         else
680                                 : $(( WRN_CNT += 1 ))
681                                 WRN_LIST="${WRN_LIST} $target"
682                         fi
683                 else
684                         rm ${LOG_DIR}/${target}.ERR
685                 fi
686         fi
687
688         OBJS=${output_dir}/u-boot
689         if [ -e ${output_dir}/spl/u-boot-spl ]; then
690                 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
691         fi
692
693         ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
694
695         [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
696
697         touch "${donep}${build_idx}"
698 }
699
700 manage_builds() {
701         search_idx=${OLDEST_IDX}
702         if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
703
704         while true; do
705                 if [ -e "${donep}${search_idx}" ] ; then
706                         : $(( CURRENT_CNT-- ))
707                         [ ${OLDEST_IDX} -eq ${search_idx} ] &&
708                                 : $(( OLDEST_IDX++ ))
709
710                         # Only want to count it once
711                         rm -f "${donep}${search_idx}"
712                         touch "${skipp}${search_idx}"
713                 elif [ -e "${skipp}${search_idx}" ] ; then
714                         [ ${OLDEST_IDX} -eq ${search_idx} ] &&
715                                 : $(( OLDEST_IDX++ ))
716                 fi
717                 : $(( search_idx++ ))
718                 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
719                         if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
720                                 search_idx=${OLDEST_IDX}
721                                 sleep 1
722                         else
723                                 break
724                         fi
725                 fi
726         done
727 }
728
729 build_targets() {
730         for t in "$@" ; do
731                 # If a LIST_xxx var exists, use it.  But avoid variable
732                 # expansion in the eval when a board name contains certain
733                 # characters that the shell interprets.
734                 case ${t} in
735                         *[-+=]*) list= ;;
736                         *)       list=$(eval echo '${LIST_'$t'}') ;;
737                 esac
738                 if [ -n "${list}" ] ; then
739                         build_targets ${list}
740                 else
741                         : $((TOTAL_CNT += 1))
742                         : $((CURRENT_CNT += 1))
743                         rm -f "${donep}${TOTAL_CNT}"
744                         rm -f "${skipp}${TOTAL_CNT}"
745                         if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
746                                 : $((SKIP_CNT += 1))
747                                 touch "${donep}${TOTAL_CNT}"
748                         elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
749                                 : $((SKIP_CNT += 1))
750                                 touch "${donep}${TOTAL_CNT}"
751                         else
752                                 if [ $BUILD_MANY == 1 ] ; then
753                                         build_target ${t} ${TOTAL_CNT} &
754                                 else
755                                         CUR_TGT="${t}"
756                                         build_target ${t} ${TOTAL_CNT}
757                                         CUR_TGT=''
758                                 fi
759                         fi
760                 fi
761
762                 # We maintain a running count of all the builds we have done.
763                 # Each finished build will have a file called ${donep}${n},
764                 # where n is the index of the build. Each build
765                 # we've already noted as finished will have ${skipp}${n}.
766                 # We track the current index via TOTAL_CNT, and the oldest
767                 # index. When we exceed the maximum number of parallel builds,
768                 # We look from oldest to current for builds that have completed,
769                 # and update the current count and oldest index as appropriate.
770                 # If we've gone through the entire list, wait a second, and
771                 # reprocess the entire list until we find a build that has
772                 # completed
773                 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
774                         manage_builds
775                 fi
776         done
777 }
778
779 #-----------------------------------------------------------------------
780
781 kill_children() {
782         local OS=$(uname -s)
783         local children=""
784         case "${OS}" in
785                 "Darwin")
786                         # Mac OS X is known to have BSD style ps
787                         local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
788                         children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
789                         ;;
790                 *)
791                         # everything else tries the GNU style
792                         local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
793                         children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
794                         ;;
795         esac
796
797         kill $children 2> /dev/null
798         wait $children 2> /dev/null
799
800         exit
801 }
802
803 print_stats() {
804         if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
805
806         # Only count boards that completed
807         : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
808
809         rm -f ${donep}* ${skipp}*
810
811         if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
812                 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
813                 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
814                 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
815                 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
816                 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
817                 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
818         else
819                 # Remove the logs for any board that was interrupted
820                 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
821         fi
822
823         : $((TOTAL_CNT -= ${SKIP_CNT}))
824         echo ""
825         echo "--------------------- SUMMARY ----------------------------"
826         if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
827                 echo "Boards skipped: ${SKIP_CNT}"
828         fi
829         echo "Boards compiled: ${TOTAL_CNT}"
830         if [ ${ERR_CNT} -gt 0 ] ; then
831                 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
832         fi
833         if [ ${WRN_CNT} -gt 0 ] ; then
834                 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
835         fi
836         echo "----------------------------------------------------------"
837
838         if [ $BUILD_MANY == 1 ] ; then
839                 kill_children
840         fi
841
842         exit $RC
843 }
844
845 #-----------------------------------------------------------------------
846
847 # Build target groups selected by options, plus any command line args
848 set -- ${SELECTED} "$@"
849 # run PowerPC by default
850 [ $# = 0 ] && set -- powerpc
851 build_targets "$@"
852 wait